// Declarations of builtin C Functions exposed to EiC to allow
// interpreted C code access to h/w resources...
#ifndef	__DBG_H__ 
#define	__DBG_H__	1
// our std shortcuts for bytes, words, dwords
#define UCHAR	unsigned char
#define USHORT	unsigned short
#define ULONG	unsigned int


// print to terminal and log file
void log_print(char *msg) ;

// PCI config reg write access...
void	WrCfg8(UCHAR regnum, UCHAR value) ;
void	WrCfg16(UCHAR regnum, USHORT value) ;
void	WrCfg32(UCHAR regnum, ULONG value) ;

// PCI config reg read access...
UCHAR	RdCfg8(UCHAR regnum) ;
USHORT	RdCfg16(UCHAR regnum) ;
ULONG	RdCfg32(UCHAR regnum) ;

// x86 i/o routines
UCHAR	inb (int port) ;
USHORT	inw (int port) ;
ULONG	ind (int port) ;
void	outb (int port, UCHAR data) ;
void	outw (int port, USHORT data) ;
void	outd (int port, ULONG data) ;

// Provide a 'pointer' to access the specified the memory region
// allocated to the specified BAR.  Since CDBG works in a DPMI
// memory management environment, the pointers is NOT the same
// as the physical address specified in the BAR!
char	*BarPtr(int bar) ;

// size of the current bar
int	BarSize(int bar) ;

// core debug function calling...
int	dbg(char *cmd_string) ;

// keyboard i/f extensions to EiC
int	kbhit(void) ;
int	getch(void) ;

// int386 hooks
void	dbg_int386(ULONG *in_array, ULONG *out_array) ;
#endif
